diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/doc/doxygen.warnings.report.sh ns-3.47/doc/doxygen.warnings.report.sh
--- ns-3.46/doc/doxygen.warnings.report.sh	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/doc/doxygen.warnings.report.sh	2026-02-16 16:08:49.485229500 -0800
@@ -1,23 +1,24 @@
 #!/bin/bash
-# -*- indent-tabs-mode:nil; -*-
 
-
-# Process doxygen log to generate sorted list of top offenders.
+# Process Doxygen log to generate sorted list of top offenders.
 #
 
 me=$(basename $0)
 DIR="$(dirname $0)"
-# Trick to get the absolute path, since doxygen prefixes errors that way
+# Trick to get the absolute path, since Doxygen prefixes errors that way
 ROOT=$(cd "$DIR/.."; pwd -P)
 
 # Known log files
-STANDARDLOGFILE=doxygen.log
-WARNINGSLOGFILE=doxygen.warnings.log
+STANDARDLOGFILE=$DIR/doxygen.log
+WARNINGSLOGFILE=$DIR/doxygen.warnings.log
 # Default choice:  generate it
-LOG="$DIR/$WARNINGSLOGFILE"
+LOG=$WARNINGSLOGFILE
 # Verbose log
 VERBLOG="$DIR/doxygen.verbose.log"
 
+# Doxygen config file
+DOXYFILE=$DIR/doxygen.conf
+
 
 # Options ------------------------------
 #
@@ -25,7 +26,7 @@
 # One line synopsis, continue
 function synopsis_short
 {
-    echo "Usage: $me [-beithv] [-s <log-file> | -l | -w] [-m <module>] [-f <regex>] [-F <regex>]"
+    echo "Usage: $me [-behiStv] [-s <log-file> | -l | -w] [-m <module>] [-f <regex>] [-F <regex>]"
 }
 
 # Two line synopsis, then exit with error
@@ -42,14 +43,13 @@
     synopsis_short
     cat <<-EOF
 
-    Run doxygen to generate all errors; report error counts
+    Run Doxygen to generate all errors; report error counts
     by module and file.
 
-    -i  Skip the build, try print-introspected-doxygen anyway.
-
-    -s  Skip doxygen run; use existing <log-file>.
-    -w  Skip doxygen run; use existing warnings log doc/$WARNINGSLOGFILE
-    -l  Skip doxygen run; use the normal doxygen log doc/$STANDARDLOGFILE
+    -i  Skip the build and introspection (introspected-doxygen, command-line)
+    -s  Skip Doxygen run; use existing <log-file>
+    -w  Skip Doxygen run; use existing warnings log $WARNINGSLOGFILE
+    -l  Skip Doxygen run; use the normal Doxygen log $STANDARDLOGFILE
 
     -b  Omit the blacklist filter of files whose warnings we ignore
     -e  Filter out warnings from */examples/*
@@ -57,21 +57,25 @@
     -m  Only include files matching src/<module>
     -f  Only include files matching the <regex>
     -F  Exclude files matching the <regex>
+    -S  Just show the summary counts, not the full listing
 
     -v  Show detailed output from each step.
     -h  Print this usage message
 
-    The default behavior is to modify doxygen.conf temporarily to
+    The default behavior is to modify $DOXYFILE temporarily to
     report all undocumented elements, and to reduce the run time.
-    The output of this special run is kept in doc/$WARNINGSLOGFILE.
+    The output of this special run is kept in $WARNINGSLOGFILE.
     To further reduce the run time, the -i option also skips
-    print-introspected-doxygen, so ns3 doesn\'t have to compile
-    any modified files at all.
+    the build, so ns3 doesn\'t have to compile any modified files at all.
+    This option necessarily skips re-generation of introspected-doxygen.h and
+    introspected-command-line.h, which rely on a clean build,
+    but these files only change when executable code changes, so this
+    isn't usually significant when just amending Doxygen comments.
 
-    The -f, -l, and -s options skip the doxygen run altogether.
+    The -l, -s, and -w options skip the Doxygen run altogether.
     The first two use a specified or the standard log file;
-    the -s option uses the warnings log from a prior run.
-    Only the first of -f <log-file>, -s, or -l will have effect.
+    the -w option uses the warnings log from a prior run.
+    Only the first of -s <log-file>, -w, or -l will have effect.
 
     The -e and -t options exclude examples and test directories
     from the counts.  The -m option only includes a specific module.
@@ -79,6 +83,11 @@
     The -m and -F options append the relevant warnings after the
     numerical report.  These can be used in any combination.
 
+    Some warnings are just nuisances, typically from third-party code
+    or constructs Doxygen has trouble with.  These are pre-loaded in to
+    the black list filter.  If you want to see what files and warnings these
+    are use the -b option.
+
 EOF
     exit 0
 }
@@ -89,6 +98,12 @@
 # Arg -v Verbosity level
 verbosity=0
 
+# Log message, possibly verbosely if -v option given
+# Non-verbose:  Print the msg (without newline), then report status of cmd
+#   verbose -n msg
+#   ...
+#   status_report $? cmd
+# Verbose:  prefix with script name
 function verbose
 {
     if [ "$1" == "-n" ]; then
@@ -98,7 +113,7 @@
             echo -n "${2}..."
         fi
     elif [ $verbosity -eq 1 ]; then
-        echo "$me:  $1 $2"
+        echo "$me: ${1:+ }$1 $2"
     else
         echo "$2"
     fi
@@ -108,6 +123,26 @@
 rm -f $VERBLOG
 exec 6>$VERBLOG
 
+# Swap back to original DOXYFILE
+# Define here so status_report can use it if needed
+function restore_doxyfile()
+{
+    if [ -e $DOXYFILE.bak ]; then
+        rm -f $DOXYFILE
+        mv -f $DOXYFILE.bak $DOXYFILE
+    fi
+}
+
+# Report status of last command
+#   status_report $? long_msg [exitonerr]
+# If status ($?) was success (0)
+#   If verbose
+#     Show detailed log of last command
+#     Verbosely log long_msg
+#   Log "done."
+# If error
+#   If verbose log FAILED and detail log
+#   If exitonerr exit the script
 function status_report
 {
     local status="$1"
@@ -121,6 +156,7 @@
         if [ $exitonerr == "yes" ]; then
             verbose "$long_msg "  "FAILED.  Details:"
             [[ -e $VERBLOG ]] && cat $VERBLOG && rm -f $VERBLOG
+            restore_doxyfile
             exit 1
         else
             verbose "$long_msg "  "FAILED, continuing"
@@ -138,12 +174,12 @@
 logfile_arg=
 # -l
 use_standard=0
-# skip doxygen run; using existing log file
+# skip Doxygen run; using existing log file
 skip_doxy=0
-# skip print-introspected-doxygen, avoiding a build
+# skip build, print-introspected-doxygen and introspected-command-line
 skip_intro=0
 
-# Filtering flags
+# Filtering flags, 1 means on/true
 filter_blacklist=1
 filter_examples=0
 filter_test=0
@@ -153,7 +189,10 @@
 filter_in=""
 filter_out=""
 
-while getopts :bef:F:hilm:s:tvw option ; do
+# Summary only
+summary_only=0
+
+while getopts :bef:F:hilm:Ss:tvw option ; do
 
     case $option in
     (b)  filter_blacklist=0       ;;
@@ -180,6 +219,8 @@
          logfile_arg="$OPTARG"
          ;;
 
+    (S)  summary_only=1           ;;
+
     (t)  filter_test=1            ;;
 
     (v)  verbosity=1
@@ -187,7 +228,7 @@
          ;;
 
     (w)  use_filearg=1
-         logfile_arg="$DIR/$WARNINGSLOGFILE"
+         logfile_arg="$WARNINGSLOGFILE"
          ;;
 
     (:)  echo "$me: Missing argument to -$OPTARG" ; synopsis ;;
@@ -197,6 +238,7 @@
     esac
 done
 
+# Check for existence of alternate Doxygen log file
 function checklogfile
 {
     if [ -e "$1" ] ; then
@@ -214,7 +256,7 @@
 if [[ $use_filearg -eq 1 && "${logfile_arg:-}" != "" ]] ; then
     checklogfile "$logfile_arg"
 elif [ $use_standard -eq 1 ]; then
-    checklogfile "$DIR/$STANDARDLOGFILE"
+    checklogfile "$STANDARDLOGFILE"
 fi
 
 # Log filters --------------------------
@@ -242,17 +284,29 @@
 # Blacklist filter of files whose warnings we ignore
 filter_blacklistRE=""
 
-#   External files: adding our own doxygen makes diffs with upstream very hard
+#   External files: adding our own Doxygen makes diffs with upstream very hard
 #     cairo-wideint
 REappend filter_blacklistRE "cairo-wideint"
+REappend filter_blacklistRE "valgrind\.h"
 
 #   Functions with varying numbers of arguments
 #   Explicit template instantiation declaration
 # REappend filter_blacklistRE "MakeCallback< ObjectBase \\* >(ObjectBase \\*"
 
+#   Global variable declarations which look like function prototypes
+REappend filter_blacklistRE "generic-battery-discharge-example.cc.*battDischFile"
+
 #   ATTRIBUTE_HELPER_CPP( and _HEADER(
-# REappend filter_blacklistRE "ATTRIBUTE_HELPER_\\(CPP\\|HEADER\\)"
+REappend filter_blacklistRE "ATTRIBUTE_HELPER_\\(CPP\\|HEADER\\)"
+
+#   NS_DEPRECATED_...(msg)
+REappend filter_blacklistRE "return type .*NS_DEPRECATED_3_"
+
+#   *.py:  we've included python files since 2012,
+#          but they are now (2025) generating warnings
+REappend filter_blacklistRE "\.py"
 
+#
 # Filter out regular expression for black list, -e, -t and -F
 filter_outRE=""
 [[ $filter_blacklist -eq 1 ]] && REappend filter_outRE "$filter_blacklistRE"
@@ -264,6 +318,7 @@
 # Configuration ------------------------
 #
 
+# Log switch values '0' as "off", not '0' as "ON"
 function on_off
 {
     if [[ "${!1:-}" != "" && "${!1}" != "0" ]] ; then
@@ -273,11 +328,24 @@
     fi
 }
 
+# Log all the filters
+function show_filters
+{
+    echo
+    echo "    Net result of all filters:"
+    [[ "${filter_blacklistRE:-}" != "" ]] && echo "      Blacklist:     \"$filter_blacklistRE\""
+    [[ "${filter_inRE:-}"  != "" ]] && echo "      Filtering in:  \"$filter_inRE\""
+    [[ "${filter_outRE:-}" != "" ]] && echo "      Filtering out: \"$filter_out\""
+
+    echo
+}
+
 if [ $verbosity -eq 1 ]; then
     echo
     echo "$me:"
     echo "    Verbose:          $(on_off verbosity)"
     echo "    Skip build:       $(on_off skip_intro)"
+    echo "    Skip Doxygen:     $(on_off skip_doxy)"
     echo "    Log file to use:  $LOG"
     echo "    Module filter:    $(on_off filter_module)  $filter_module"
     echo "    Examples filter:  $(on_off filter_examples)"
@@ -285,49 +353,43 @@
     echo "    Blacklist filter: $(on_off filter_blacklist)"
     echo "    Filter in:        $(on_off filter_in)  $filter_in"
     echo "    Filter out:       $(on_off filter_out)  $filter_out"
-    echo
+    echo "    Summary only:     $(on_off summary_only)"
 
     #  Show the resulting filters here, in addition to below
-    echo "    Net result of all filters:"
-    [[ "${filter_inRE:-}"  != "" ]] && echo "      Filtering in:   \"$filter_inRE\""
-    [[ "${filter_outRE:-}" != "" ]] && echo "      Filtering out:  \"$filter_outRE\""
-
-    echo
+    show_filters
 fi
 
 
-#  Run doxygen -------------------------
+#  Run Doxygen -------------------------
 #
 
 if [ $skip_doxy -eq 1 ]; then
     echo
-    echo "Skipping doxygen run, using existing log file $LOG"
+    echo "Skipping Doxygen run, using existing log file $LOG"
 
 else
 
-    # We're going to modify doxygen.conf
+    # We're going to modify DOXYFILE
     # In case the user ^C's out of this we need to restore
-    # doxygen.conf, otherwise weird things happen.
-    # function restore_doxygen_conf defined below
-    trap restore_doxygen_conf INT
+    # DOXYFILE, otherwise weird things happen the next time
+    # they build Doxygen
+    trap restore_doxyfile INT
 
-    # Modify doxygen.conf to generate all the warnings
+    # Modify DOXYFILE to generate all the warnings
     # We keep dot active to generate graphs in the documentation
     # (see for example PacketTagList) and warn about ill-formed
-    # graphs, but we disable all the doxygen-generated diagrams
+    # graphs, but we disable all the Doxygen-generated diagrams
     # to shorten the run time.
 
-    conf=doc/doxygen.conf
-    cp $conf ${conf}.bak
-    cat <<-EOF >> $conf
+    cp $DOXYFILE ${DOXYFILE}.bak
+    cat <<-EOF >> $DOXYFILE
 
     # doxygen.warnings.report.sh:
     EXTRACT_ALL = no
     WARNINGS = no
-    WARN_LOGFILE = doc/$WARNINGSLOGFILE
+    WARN_LOGFILE = $WARNINGSLOGFILE
     SOURCE_BROWSER = no
     HTML_OUTPUT = html-warn
-    CLASS_DIAGRAMS = no
     CLASS_GRAPH = no
     COLLABORATION_GRAPH = no
     GROUP_GRAPHS = no
@@ -339,36 +401,26 @@
     DIRECTORY_GRAPH = no
 EOF
 
-    # Swap back to original config
-    function restore_doxygen_conf()
-    {
-        if [ -e $conf.bak ]; then
-            rm -f $conf
-            mv -f $conf.bak $conf
-        fi
-    }
-
-    intro_h="introspected-doxygen.h"
+    doxycmd="doxygen-no-build"
     if [ $skip_intro -eq 1 ]; then
-        verbose "" "Skipping ./ns3 build"
-        verbose -n "Trying print-introspected-doxygen with doxygen build"
-        (cd "$ROOT" && ./ns3 run print-introspected-doxygen --no-build >doc/$intro_h 2>&6 )
-        status_report $? "./ns3 run print-introspected-doxygen" noexit
+        verbose "" "Skipping ./ns3 build, print-introspected-doxygen, and introspected-command-line"
+
     else
         # Run introspection, which may require a build
         verbose -n "Building"
         (cd "$ROOT" && ./ns3 build >&6 2>&6 )
         status_report $? "./ns3 build"
-        verbose -n "Running print-introspected-doxygen with doxygen build"
-        (cd "$ROOT" && ./ns3 run print-introspected-doxygen --no-build >doc/$intro_h 2>&6 )
-        status_report $? "./ns3 run print-introspected-doxygen"
+
+        doxycmd=doxygen
     fi
 
-    verbose -n "Rebuilding doxygen docs with full errors"
-    (cd "$ROOT" && ./ns3 docs doxygen-no-build >&6 2>&6 )
-    status_report $? "./ns3 docs doxygen-no-build"
+    echo "Doxygen@version:" `which doxygen` "@" `doxygen --version`
+    verbose "" "Repo version: $(cd $ROOT && doc/ns3_html_theme/get_version.sh | cut -d ':' -f 2- )"
+    verbose -n "Rebuilding Doxygen docs with full errors"
+    (cd "$ROOT" && ./ns3 docs $doxycmd >&6 2>&6 )
+    status_report $? "./ns3 docs $doxycmd"
 
-    restore_doxygen_conf
+    restore_doxyfile
 fi
 
 # Filter log file
@@ -382,6 +434,7 @@
 
     flog=$(                         \
         echo "$flog"              | \
+        sed "s|^$ROOT/||g"         | \
         sort -t ':' -k1,1 -k2,2n  | \
         uniq                        \
         )
@@ -391,13 +444,12 @@
 
 # Analyze the log ----------------------
 #
-#  Show the resulting filters
-echo
-echo "Net result of all filters:"
-[[ "${filter_inRE:-}"  != "" ]] && echo "Filtering in \"$filter_inRE\""
-[[ "${filter_outRE:-}" != "" ]] && echo "Filtering out \"$filter_outRE\""
+#  Show the resulting filters, if not already shown by verbose
+if [[ $verbosity -ne 1 && ! -z "$filter_log_results" ]]; then
+    show_filters
+fi
 
-verbose -n "Filtering the doxygen log"
+verbose -n "Filtering the Doxygen log $LOG"
 
 filter_log_results=$(filter_log)
 
@@ -439,7 +491,7 @@
     sed 's/^[ \t]*//;s/[ \t]*$//'             \
     )
 
-# Sometimes doxygen can not pinpoint a warning to an exact file.
+# Sometimes Doxygen can not pinpoint a warning to an exact file.
 # In this case the output is of the form:
 # "<operator==>:1: warning: parameters of member ns3::operator== are not documented"
 # or
@@ -512,6 +564,13 @@
 
 # Summarize the log --------------------
 #
+# Return status based on warnings
+exit_status=$((warncount > 0))
+
+if ((warncount == 0)); then
+   echo "No warnings passed the filters."
+   exit $exit_status
+fi
 
 echo
 echo "Report of Doxygen warnings"
@@ -576,9 +635,6 @@
 printf "%6d files\n" $filecount
 printf "%6d warnings\n" $warncount
 
-# Return status based on warnings
-exit_status=$((warncount > 0))
-
 # if [ "${filter_inRE:-}" != "" ] ; then
 #     if [ "$filterin" != "" ] ; then
 #         echo
@@ -592,6 +648,12 @@
 #     fi
 # fi
 
+# Summary only: quit now
+if [ "$summary_only" == 1 ]; then
+    status_report 0 $me
+    exit $exit_status
+fi
+
 if [ "$filterin" != "" ] ; then
     echo
     echo
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/doc/models/Makefile ns-3.47/doc/models/Makefile
--- ns-3.46/doc/models/Makefile	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/doc/models/Makefile	2026-02-16 16:08:49.528229500 -0800
@@ -19,6 +19,10 @@
 	$(SRC)/antenna/doc/antenna.rst \
 	$(SRC)/aodv/doc/aodv.rst \
 	$(SRC)/applications/doc/applications.rst \
+        $(SRC)/applications/doc/rta-tig-mobile-gaming-traffic.inc \
+        $(SRC)/applications/doc/tgax-video-traffic.inc \
+        $(SRC)/applications/doc/tgax-virtual-desktop-traffic.inc \
+        $(SRC)/applications/doc/tgax-voip-traffic.inc \
 	$(SRC)/bridge/doc/bridge.rst \
 	$(SRC)/brite/doc/brite.rst \
 	$(SRC)/buildings/doc/source/buildings.rst \
@@ -60,6 +64,7 @@
 	$(SRC)/internet/doc/ipv4.rst \
 	$(SRC)/internet/doc/ipv6.rst \
 	$(SRC)/internet/doc/routing-overview.rst \
+	$(SRC)/internet/doc/global-routing.rst \
 	$(SRC)/internet/doc/tcp.rst \
 	$(SRC)/internet/doc/udp.rst \
 	$(SRC)/internet-apps/doc/internet-apps.rst \
@@ -125,6 +130,10 @@
 	$(SRC)/internet/doc/routing-specialization.dia \
 	$(SRC)/internet/doc/global-routing-limitation.dia \
 	$(SRC)/internet/doc/figures/tcp-state-machine.png \
+	$(SRC)/internet/doc/figures/fack-cwnd.png \
+	$(SRC)/internet/doc/figures/fack-inflight.png \
+	$(SRC)/internet/doc/figures/fack-packetDrops.png \
+	$(SRC)/internet/doc/figures/fack-throughput.png\
 	$(SRC)/internet/doc/figures/dctcp-10ms-50mbps-tcp-throughput.pdf \
 	$(SRC)/internet/doc/figures/dctcp-10ms-50mbps-tcp-throughput.png \
 	$(SRC)/internet/doc/figures/dctcp-80ms-50mbps-tcp-throughput.pdf \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/doc/ns3_html_theme/get_version.sh ns-3.47/doc/ns3_html_theme/get_version.sh
--- ns-3.46/doc/ns3_html_theme/get_version.sh	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/doc/ns3_html_theme/get_version.sh	2026-02-16 16:08:49.528229500 -0800
@@ -48,17 +48,38 @@
 #
 
 me=`basename $0`
+
+# Controls
+
+# Build public URLs
+public=0
+# Build URLs for nsnam.org
+nsnam=0
+# Build for nsnam automated build directory
+daily=0
+# Build at a tag
+tag=0
+# Show progress details and final JS variables
+verbose=0
+
+
 function say
 {
     echo "$me: $*"
 }
 
+function verb
+{
+    [[ $verbose -eq 1 ]] && say $* || :
+}
+
 function usage
 {
     cat <<-EOF
-    Usage:  $me [-p]              normal versioning
+    Usage:  $me [-pv]             normal versioning
             $me [-n] [-d] [-t]    test options
       -p  build public urls, NS3_WWW_URLS=public is an alternative
+      -v  verbose: show output javascript variables
 
     Testing options:
       -n  pretend we are on nsnam.org
@@ -69,15 +90,7 @@
     exit 1
 }
 
-# script arguments
-say
-say using doxygen: $(which doxygen) $(doxygen --version)
-public=0
-nsnam=0
-daily=0
-tag=0
-
-while getopts :pndth option ; do
+while getopts :pndtvh option ; do
     case $option in
     (p)  public=1 ;;
     (n)  nsnam=1  ;;
@@ -86,12 +99,18 @@
 
     (t)  tag=1    ;;
 
+    (v)  verbose=1 ;;
+
     (h)  usage ;;
     (:)  say "Missing argument to -$OPTARG" ; usage ;;
     (\?) say "Invalid option: -$OPTARG"     ; usage ;;
     esac
 done
 
+# script arguments
+verb
+verb using doxygen: $(which doxygen) $(doxygen --version)
+
 # Hostname, fully qualified, e.g. nsnam-www.coe-hosted.gatech.edu
 HOST=`hostname`
 NSNAM="nsnam-www.coe-hosted.gatech.edu"
@@ -101,18 +120,18 @@
 
 if [ $nsnam -eq 1 ]; then
     HOST=$NSNAM
-    say "-n forcing HOST = $HOST"
+    verb "-n forcing HOST = $HOST"
 fi
 
 if [ $daily -eq 1 ] ; then
     OLDPWD=$PWD
     PWD=/tmp/daily-nsnam/foo
-    say "-d forcing PWD = $PWD"
+    verb "-d forcing PWD = $PWD"
 fi
 
 if [ $tag -eq 1 ]; then
     version="ns-3.14"
-    say "-t forcing tagged version = $version"
+    verb "-t forcing tagged version = $version"
 fi
 
 if  ((nsnam + daily + tag > 0)) ; then
@@ -123,10 +142,10 @@
     ("${NS3_WWW_URLS:-}" == "public") || \
     ( ($HOST == $NSNAM) && ($PWD =~ $DAILY) ) ]] ; then
     PUBLIC=1
-    say "building public docs for nsnam.org"
+    verb "building public docs for nsnam.org"
 else
     PUBLIC=0
-    say "building private docs"
+    verb "building private docs"
 fi
 
 if [ $daily -eq 1 ]; then
@@ -144,7 +163,7 @@
 
 if [ $distance -eq 1 ] | [ $distance -eq 0 ]; then
     version=`git describe HEAD --tags --long | cut -d '-' -f 2`
-    say "at version $version"
+    verb "at version $version"
 
 elif [ $tag -eq 1 ]; then
     distance=1
@@ -214,7 +233,7 @@
 cd - 2>&1 >/dev/null
 
 # Show what was done
-say
-say "outf = $outf:"
-cat -n $outf
-say Done.
+verb
+verb "outf = $outf:"
+[[ $verbose -eq 1 ]] && cat -n $outf
+verb Done.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/examples/channel-models/examples-to-run.py ns-3.47/examples/channel-models/examples-to-run.py
--- ns-3.46/examples/channel-models/examples-to-run.py	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/examples/channel-models/examples-to-run.py	2026-02-16 16:08:49.557229800 -0800
@@ -8,6 +8,11 @@
 # See test.py for more information.
 cpp_examples = [
     ("three-gpp-v2v-channel-example", "True", "True"),
+    (
+        "three-gpp-v2v-channel-example --updatePeriodMs=1",
+        "True",
+        "True",
+    ),
 ]
 
 # A list of Python examples to run in order to ensure that they remain
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/examples/channel-models/three-gpp-v2v-channel-example.cc ns-3.47/examples/channel-models/three-gpp-v2v-channel-example.cc
--- ns-3.46/examples/channel-models/three-gpp-v2v-channel-example.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/examples/channel-models/three-gpp-v2v-channel-example.cc	2026-02-16 16:08:49.557229800 -0800
@@ -6,20 +6,21 @@
  */
 
 /*
- * This is an example on how to configure the channel model classes to simulate
+ * @file
+ * This is an example of how to configure the channel model classes to simulate
  * a vehicular environment.
  * The channel condition is determined using the model specified in [1], Table 6.2-1.
  * The pathloss is determined using the model specified in [1], Table 6.2.1-1.
  * The model for the fast fading is the one described in 3GPP TR 38.901 v15.0.0,
  * the model parameters are those specified in [1], Table 6.2.3-1.
  *
- * This example generates the output file 'example-output.txt'. Each row of the
- * file is organized as follows:
- * Time[s] TxPosX[m] TxPosY[m] RxPosX[m] RxPosY[m] ChannelState SNR[dB] Pathloss[dB]
- * We also provide a bash script which reads the output file and generates two
+ * This example generates the output file 'three-gpp-v2v-channel-example-output.txt'. Each row of
+ * the file is organized as follows: Time[s] TxPosX[m] TxPosY[m] RxPosX[m] RxPosY[m] ChannelState
+ * SNR[dB] Pathloss[dB] We also provide a bash script which reads the output file and generates two
  * figures:
- * (i) map.gif, a GIF representing the simulation scenario and vehicle mobility;
- * (ii) snr.png, which represents the behavior of the SNR.
+ * (i) three-gpp-v2v-channel-example-map.gif, a GIF representing the simulation scenario and vehicle
+ * mobility;
+ * (ii) three-gpp-v2v-channel-example-snr.png, which represents the behavior of the SNR.
  *
  * [1] 3GPP TR 37.885, v15.3.0
  */
@@ -64,31 +65,22 @@
 
 /**
  * Perform the beamforming using the DFT beamforming method
- * @param thisDevice the device performing the beamforming
+ * @param txMob the mobility model of the node performing the beamforming
  * @param thisAntenna the antenna object associated to thisDevice
- * @param otherDevice the device towards which point the beam
+ * @param rxMob the mobility model of the node towards which will point the beam
  */
 static void
-DoBeamforming(Ptr<NetDevice> thisDevice,
-              Ptr<PhasedArrayModel> thisAntenna,
-              Ptr<NetDevice> otherDevice)
+DoBeamforming(Ptr<MobilityModel> txMob, Ptr<PhasedArrayModel> thisAntenna, Ptr<MobilityModel> rxMob)
 {
-    PhasedArrayModel::ComplexVector antennaWeights;
-
-    // retrieve the position of the two devices
-    Vector aPos = thisDevice->GetNode()->GetObject<MobilityModel>()->GetPosition();
-    Vector bPos = otherDevice->GetNode()->GetObject<MobilityModel>()->GetPosition();
-
     // compute the azimuth and the elevation angles
-    Angles completeAngle(bPos, aPos);
-
+    Angles completeAngle(rxMob->GetPosition(), txMob->GetPosition());
     PhasedArrayModel::ComplexVector bf = thisAntenna->GetBeamformingVector(completeAngle);
     thisAntenna->SetBeamformingVector(bf);
 }
 
 /**
  * Compute the average SNR
- * @param params A structure that holds a bunch of parameters needed by ComputSnr function to
+ * @param params A structure that holds a bunch of parameters needed by ComputeSnr function to
  * calculate the average SNR
  */
 static void
@@ -96,13 +88,11 @@
 {
     // check the channel condition
     Ptr<ChannelCondition> cond = m_condModel->GetChannelCondition(params.txMob, params.rxMob);
-
     // apply the pathloss
     double propagationGainDb = m_propagationLossModel->CalcRxPower(0, params.txMob, params.rxMob);
     NS_LOG_DEBUG("Pathloss " << -propagationGainDb << " dB");
     double propagationGainLinear = std::pow(10.0, (propagationGainDb) / 10.0);
     *(params.txParams->psd) *= propagationGainLinear;
-
     // apply the fast fading and the beamforming gain
     auto rxParams = m_spectrumLossModel->CalcRxPowerSpectralDensity(params.txParams,
                                                                     params.txMob,
@@ -120,13 +110,11 @@
     double noisePowerSpectralDensity = kT_W_Hz * noiseFigureLinear;
     Ptr<SpectrumValue> noisePsd = Create<SpectrumValue>(params.txParams->psd->GetSpectrumModel());
     (*noisePsd) = noisePowerSpectralDensity;
-
-    // compute the SNR
+    // log the average SNR
     NS_LOG_DEBUG("Average SNR " << 10 * log10(Sum(*rxPsd) / Sum(*noisePsd)) << " dB");
-
-    // print the SNR and pathloss values in the snr-trace.txt file
+    // print the SNR and pathloss values in the three-gpp-v2v-channel-example-output.txt file
     std::ofstream f;
-    f.open("example-output.txt", std::ios::out | std::ios::app);
+    f.open("three-gpp-v2v-channel-example-output.txt", std::ios::out | std::ios::app);
     f << Simulator::Now().GetSeconds() << " " // time [s]
       << params.txMob->GetPosition().x << " " << params.txMob->GetPosition().y << " "
       << params.rxMob->GetPosition().x << " " << params.rxMob->GetPosition().y << " "
@@ -170,28 +158,20 @@
     double vScatt = 0;                  // maximum speed of the vehicles in the scenario [m/s]
     double subCarrierSpacing = 60e3;    // subcarrier spacing in kHz
     uint32_t numRb = 275;               // number of resource blocks
+    uint32_t updatePeriodMs = 0;
 
     CommandLine cmd(__FILE__);
     cmd.AddValue("frequency", "operating frequency in Hz", frequency);
     cmd.AddValue("txPow", "tx power in dBm", txPow_dbm);
     cmd.AddValue("noiseFigure", "noise figure in dB", noiseFigure);
     cmd.AddValue("scenario", "3GPP propagation scenario, V2V-Urban or V2V-Highway", scenario);
+    cmd.AddValue("updatePeriodMs", "the channel update period", updatePeriodMs);
     cmd.Parse(argc, argv);
 
     // create the nodes
     NodeContainer nodes;
     nodes.Create(2);
 
-    // create the tx and rx devices
-    Ptr<SimpleNetDevice> txDev = CreateObject<SimpleNetDevice>();
-    Ptr<SimpleNetDevice> rxDev = CreateObject<SimpleNetDevice>();
-
-    // associate the nodes and the devices
-    nodes.Get(0)->AddDevice(txDev);
-    txDev->SetNode(nodes.Get(0));
-    nodes.Get(1)->AddDevice(rxDev);
-    rxDev->SetNode(nodes.Get(1));
-
     // create the antenna objects and set their dimensions
     Ptr<PhasedArrayModel> txAntenna =
         CreateObjectWithAttributes<UniformPlanarArray>("NumColumns",
@@ -321,6 +301,7 @@
     channelModel->SetAttribute("Frequency", DoubleValue(frequency));
     channelModel->SetAttribute("ChannelConditionModel", PointerValue(m_condModel));
     channelModel->SetAttribute("vScatt", DoubleValue(vScatt));
+    channelModel->SetAttribute("UpdatePeriod", TimeValue(MilliSeconds(updatePeriodMs)));
 
     // create the spectrum propagation loss model
     m_spectrumLossModel = CreateObjectWithAttributes<ThreeGppSpectrumPropagationLossModel>(
@@ -330,8 +311,8 @@
     BuildingsHelper::Install(nodes);
 
     // set the beamforming vectors
-    DoBeamforming(txDev, txAntenna, rxDev);
-    DoBeamforming(rxDev, rxAntenna, txDev);
+    DoBeamforming(txMob, txAntenna, rxMob);
+    DoBeamforming(rxMob, rxAntenna, txMob);
 
     // create the tx power spectral density
     Bands rbs;
@@ -340,9 +321,9 @@
     {
         BandInfo rb;
         rb.fl = freqSubBand;
-        freqSubBand += subCarrierSpacing / 2;
+        freqSubBand += (subCarrierSpacing * 12) / 2;
         rb.fc = freqSubBand;
-        freqSubBand += subCarrierSpacing / 2;
+        freqSubBand += (subCarrierSpacing * 12) / 2;
         rb.fh = freqSubBand;
         rbs.push_back(rb);
     }
@@ -350,7 +331,7 @@
     Ptr<SpectrumValue> txPsd = Create<SpectrumValue>(spectrumModel);
     Ptr<SpectrumSignalParameters> txParams = Create<SpectrumSignalParameters>();
     double txPow_w = std::pow(10., (txPow_dbm - 30) / 10);
-    double txPowDens = (txPow_w / (numRb * subCarrierSpacing));
+    double txPowDens = (txPow_w / (numRb * subCarrierSpacing * 12));
     (*txPsd) = txPowDens;
     txParams->psd = txPsd->Copy();
 
@@ -362,13 +343,13 @@
 
     // initialize the output file
     std::ofstream f;
-    f.open("example-output.txt", std::ios::out);
+    f.open("three-gpp-v2v-channel-example-output.txt", std::ios::out);
     f << "Time[s] TxPosX[m] TxPosY[m] RxPosX[m] RxPosY[m] ChannelState SNR[dB] Pathloss[dB]"
       << std::endl;
     f.close();
 
     // print the list of buildings to file
-    PrintGnuplottableBuildingListToFile("buildings.txt");
+    PrintGnuplottableBuildingListToFile("three-gpp-v2v-channel-example-buildings.txt");
 
     Simulator::Run();
     Simulator::Destroy();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/examples/channel-models/three-gpp-v2v-channel-example.py ns-3.47/examples/channel-models/three-gpp-v2v-channel-example.py
--- ns-3.46/examples/channel-models/three-gpp-v2v-channel-example.py	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/examples/channel-models/three-gpp-v2v-channel-example.py	2026-02-16 16:08:49.557229800 -0800
@@ -15,7 +15,7 @@
 import pandas as pd
 
 # Load the data
-df = pd.read_csv("example-output.txt", sep=r"\s+", comment="#")
+df = pd.read_csv("three-gpp-v2v-channel-example-output.txt", sep=r"\s+", comment="#")
 df = df.iloc[::10, :]
 
 # Column indices (adjust if needed)
@@ -48,7 +48,9 @@
 ax_snr.grid(True)
 (snr_line,) = ax_snr.plot([], [], "k-")
 
-buildings = pd.read_csv("buildings.txt", sep=r"\s+", comment="#", header=None)
+buildings = pd.read_csv(
+    "three-gpp-v2v-channel-example-buildings.txt", sep=r"\s+", comment="#", header=None
+)
 building_patches = []
 for idx, row in buildings.iterrows():
     x0, y0, x1, y1 = row
@@ -73,7 +75,7 @@
 ani = animation.FuncAnimation(fig, update, frames=len(df), interval=0.001, blit=False)
 
 # Save animation
-ani.save("map.gif", writer="pillow")
+ani.save("three-gpp-v2v-channel-example-map.gif", writer="pillow")
 
 # Save final SNR plot separately
 plt.figure()
@@ -83,4 +85,4 @@
 plt.grid(True)
 plt.xlim(0, 40)
 plt.ylim(-20, 100)
-plt.savefig("snr.png")
+plt.savefig("three-gpp-v2v-channel-example-snr.png")
